Subject: Re: bug#37785: [PATCH] Add a way to disable substitution of command keys in help strings

From: Eli Zaretskii <[email-masked]>
Date: Thu, 17 Oct 2019 20:18:58 +0300

> Cc: [email-masked], [email-masked]
> From: Clément Pit-Claudel <[email-masked]>
> Date: Thu, 17 Oct 2019 11:53:45 -0400
> 
> I've attached an updated patch.

Thanks, I have a few minor comments.

> * src/keyboard.c (help_echo_substitute_command_keys): New function

Missing period at end of sentence.

> diff --git a/doc/lispref/text.texi b/doc/lispref/text.texi
> index d7b04d2934..22a007592b 100644
> --- a/doc/lispref/text.texi
> +++ b/doc/lispref/text.texi
> @@ -3736,9 +3736,11 @@ Special Properties
>  @pxref{Extended Menu Items}), or tool bar help strings (@pxref{Tool
>  Bar}).  The specified function is called with one argument, the help
>  string to display, which is passed through
> -@code{substitute-command-keys} before being given to the function; see
> -@ref{Keys in Documentation}.  Tooltip mode (@pxref{Tooltips,,, emacs,
> -The GNU Emacs Manual}) provides an example.
> +@code{substitute-command-keys} before being given to the function,
> +unless the help string has a non-nil
                                ^^^^^^
In the Info manuals, we give "nil" the @code markup: non-@code{nil}.

Please also add here an index entry, so that readers could find this
information quickly.  Suggestion:

 @cindex help-echo text, avoid command-key substitution

Also, please add the description of this face to the list in "Special
Properties".

> +** New text property 'help-echo-inhibit-substitution'.
> +Setting this on the first character of a help string disables
> +conversion via 'substitute-command-keys'.
   ^^^^^^^^^^
I'd use "conversions" here, in plural.

> +  return Fsubstitute_command_keys(help);
                                    ^
Our convention is to leave one blank between a function's name and the
opening parenthesis.